print("\134\3* FRIENDMOD, by TyroneSama *")

-- documentation for these is in the release post tbh
local fr_enabled = CV_RegisterVar({
	name = "fr_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamchance = CV_RegisterVar({
	name = "fr_teamchance",
	defaultvalue = "100",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_minplayers = CV_RegisterVar({
	name = "fr_minplayers",
	defaultvalue = "0",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_teamattack = CV_RegisterVar({
	name = "fr_teamattack",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(var)
		if not var.value then
			print("\133DISABLING TEAM ATTACK SEVERELY SCREWS UP TEAMPLAY DYNAMICS AND BALANCE!")
			print("This should only be used for very specific gameplay experiments. \133Don't say I didn't warn you.")
		end
	end
})
local fr_teamwarning = CV_RegisterVar({
	name = "fr_teamwarning",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamreflect = CV_RegisterVar({
	name = "fr_teamreflect",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamlog = CV_RegisterVar({
	name = "fr_teamlog",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_debug = CV_RegisterVar({
	name = "fr_debug",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_crewbattle = CV_RegisterVar({
	name = "fr_crewbattle",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_crewfill = CV_RegisterVar({
	name = "fr_crewfill",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bosschance = CV_RegisterVar({
	name = "fr_bosschance",
	defaultvalue = "5",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossrestock = CV_RegisterVar({
	name = "fr_bossrestock",
	defaultvalue = "4",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossspbgone = CV_RegisterVar({
	name = "fr_bossspbgone",
	defaultvalue = "2",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossshrinkbgone = CV_RegisterVar({
	name = "fr_bossshrinkbgone",
	defaultvalue = "2",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossprotectitem = CV_RegisterVar({
	name = "fr_bossprotectitem",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossprotectamount = CV_RegisterVar({
	name = "fr_bossprotectamount",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossprotectfront = CV_RegisterVar({
	name = "fr_bossprotectfront",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bossstartitem = CV_RegisterVar({
	name = "fr_bossstartitem",
	defaultvalue = "16",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossstartamount = CV_RegisterVar({
	name = "fr_bossstartamount",
	defaultvalue = "3",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossscalerestock = CV_RegisterVar({
	name = "fr_bossscalerestock",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bosskarma = CV_RegisterVar({
	name = "fr_bosskarma",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldkarma = CV_RegisterVar({
	name = "fr_worldkarma",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldpower = CV_RegisterVar({
	name = "fr_worldpower",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldjawz = CV_RegisterVar({
	name = "fr_worldjawz",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldpoweralways = CV_RegisterVar({
	name = "fr_worldpoweralways",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldjawzalways = CV_RegisterVar({
	name = "fr_worldjawzalways",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldreplaceitem = CV_RegisterVar({
	name = "fr_worldreplaceitem",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_worldreplaceamount = CV_RegisterVar({
	name = "fr_worldreplaceamount",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bluename = CV_RegisterVar({
	name = "fr_bluename",
	defaultvalue = "Random",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_orangename = CV_RegisterVar({
	name = "fr_orangename",
	defaultvalue = "Random",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_onesidename = CV_RegisterVar({
	name = "fr_onesidename",
	defaultvalue = "THE WORLD",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_forceboss = CV_RegisterVar({
	name = "fr_forceboss",
	defaultvalue = "Random",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_bluecolor = CV_RegisterVar({
	name = "fr_bluecolor",
	defaultvalue = "Blue",
	flags = CV_NETVAR,
	possiblevalue = {White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})
local fr_orangecolor = CV_RegisterVar({
	name = "fr_orangecolor",
	defaultvalue = "Orange",
	flags = CV_NETVAR,
	possiblevalue = {White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})

local fr_bluecolorlocal = CV_RegisterVar({
	name = "fr_bluecolorlocal",
	defaultvalue = 0,
	possiblevalue = {MIN = 0, White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})
local fr_orangecolorlocal = CV_RegisterVar({
	name = "fr_orangecolorlocal",
	defaultvalue = 0,
	possiblevalue = {MIN = 0, White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})

-- this is used to translate team colors into text colors for HUD stuff
-- technically these should probably be different options because the text colors are pretty heavily "LOL BEST ESTIMATE MAYBE?"
-- but this is the way most people expect it to work so hey
local colLookup = { -- thanks ampersand
	-- White
	[SKINCOLOR_WHITE] = "\x80",
	[SKINCOLOR_SILVER] = "\x80",
	[SKINCOLOR_SLATE] = "\x80",
	
	-- V_PURPLEMAP
	[SKINCOLOR_ULTRAVIOLET] = "\x81",
	[SKINCOLOR_PURPLE] = "\x81",
	[SKINCOLOR_FUCHSIA] = "\x81",
	
	-- V_YELLOWMAP
	[SKINCOLOR_POPCORN] = "\x82",
	[SKINCOLOR_QUARRY] = "\x82",
	[SKINCOLOR_YELLOW] = "\x82",
	[SKINCOLOR_MUSTARD] = "\x82",
	[SKINCOLOR_CROCODILE] = "\x82",
	[SKINCOLOR_OLIVE] = "\x82",
	
	-- V_GREENMAP
	[SKINCOLOR_LIME] = "\x83",
	[SKINCOLOR_HANDHELD] = "\x83",
	[SKINCOLOR_MOSS] = "\x83",
	[SKINCOLOR_CAMOUFLAGE] = "\x83",
	[SKINCOLOR_ROBOHOOD] = "\x83",
	[SKINCOLOR_MINT] = "\x83",
	[SKINCOLOR_GREEN] = "\x83",
	[SKINCOLOR_PINETREE] = "\x83",
	[SKINCOLOR_ALGAE] = "\x83",
	[SKINCOLOR_PLAGUE] = "\x83",
	[SKINCOLOR_EMERALD] = "\x83",
	[SKINCOLOR_SWAMP] = "\x83",
	[SKINCOLOR_DREAM] = "\x83",
	
	-- V_BLUEMAP
	[SKINCOLOR_PERIWINKLE] = "\x84",
	[SKINCOLOR_BLUE] = "\x84",
	[SKINCOLOR_BLUEBERRY] = "\x84",
	[SKINCOLOR_NOVA] = "\x84",
	
	-- V_REDMAP
	[SKINCOLOR_CINNAMON] = "\x85",
	[SKINCOLOR_RUBY] = "\x85",
	[SKINCOLOR_RASPBERRY] = "\x85",
	[SKINCOLOR_CHERRY] = "\x85",
	[SKINCOLOR_RED] = "\x85",
	[SKINCOLOR_CRIMSON] = "\x85",
	[SKINCOLOR_MAROON] = "\x85",
	[SKINCOLOR_FLAME] = "\x85",
	[SKINCOLOR_SCARLET] = "\x85",
	[SKINCOLOR_KETCHUP] = "\x85",
	
	-- V_GRAYMAP
	[SKINCOLOR_GREY] = "\x86",
	[SKINCOLOR_NICKEL] = "\x86",
	[SKINCOLOR_BLACK] = "\x86",
	[SKINCOLOR_SKUNK] = "\x86",
	[SKINCOLOR_JET] = "\x86",
	
	-- V_ORANGEMAP
	[SKINCOLOR_DAWN] = "\x87",
	[SKINCOLOR_SUNSET] = "\x87",
	[SKINCOLOR_CREAMSICLE] = "\x87",
	[SKINCOLOR_ORANGE] = "\x87",
	[SKINCOLOR_PUMPKIN] = "\x87",
	[SKINCOLOR_ROSEWOOD] = "\x87",
	[SKINCOLOR_BURGUNDY] = "\x87",
	[SKINCOLOR_TANGERINE] = "\x87",
	
	-- V_SKYMAP
	[SKINCOLOR_CARIBBEAN] = "\x88",
	[SKINCOLOR_AZURE] = "\x88",
	[SKINCOLOR_AQUA] = "\x88",
	[SKINCOLOR_TEAL] = "\x88",
	[SKINCOLOR_CYAN] = "\x88",
	[SKINCOLOR_JAWZ] = "\x88",
	[SKINCOLOR_CERULEAN] = "\x88",
	[SKINCOLOR_NAVY] = "\x88",
	[SKINCOLOR_SAPPHIRE] = "\x88",
	
	-- V_LAVENDERMAP
	[SKINCOLOR_PASTEL] = "\x89",
	[SKINCOLOR_MOONSLAM] = "\x89",
	[SKINCOLOR_DUSK] = "\x89",
	[SKINCOLOR_TOXIC] = "\x89",
	[SKINCOLOR_MAUVE] = "\x89",
	[SKINCOLOR_LAVENDER] = "\x89",
	[SKINCOLOR_BYZANTIUM] = "\x89",
	[SKINCOLOR_POMEGRANATE] = "\x89",
	
	-- V_GOLDMAP
	[SKINCOLOR_GOLD] = "\x8A",
	[SKINCOLOR_ROYAL] = "\x8A",
	[SKINCOLOR_BRONZE] = "\x8A",
	[SKINCOLOR_COPPER] = "\x8A",
	[SKINCOLOR_THUNDER] = "\x8A",
	
	-- V_TEAMAP
	[SKINCOLOR_ARTICHOKE] = "\x8B",
	[SKINCOLOR_VOMIT] = "\x8B",
	[SKINCOLOR_GARDEN] = "\x8B",
	[SKINCOLOR_TEA] = "\x8B",
	[SKINCOLOR_PISTACHIO] = "\x8B",
	
	-- V_STEELMAP
	[SKINCOLOR_PIGEON] = "\x8C",
	[SKINCOLOR_PLATINUM] = "\x8C",
	[SKINCOLOR_STEEL] = "\x8C",
	
	-- V_PINKMAP
	[SKINCOLOR_FAIRY] = "\x8D",
	[SKINCOLOR_SALMON] = "\x8D",
	[SKINCOLOR_PINK] = "\x8D",
	[SKINCOLOR_ROSE] = "\x8D",
	[SKINCOLOR_BRICK] = "\x8D",
	[SKINCOLOR_LEMONADE] = "\x8D",
	[SKINCOLOR_BUBBLEGUM] = "\x8D",
	[SKINCOLOR_LILAC] = "\x8D",
	
	-- V_BROWNMAP
	[SKINCOLOR_SEPIA] = "\x8E",
	[SKINCOLOR_BEIGE] = "\x8E",
	[SKINCOLOR_WALNUT] = "\x8E",
	[SKINCOLOR_BROWN] = "\x8E",
	[SKINCOLOR_LEATHER] = "\x8E",
	[SKINCOLOR_RUST] = "\x8E",
	[SKINCOLOR_WRISTWATCH] = "\x8E",
	
	-- V_PEACHMAP
	[SKINCOLOR_PEACH] = "\x8F",
	[SKINCOLOR_CARAMEL] = "\x8F",
	[SKINCOLOR_CREAM] = "\x8F",
}

-- adapted from LJ Sonic's PRNG library
-- i am so fucking sorry
-- this is the only way i found to get random elements to sync in replays, please fix in 2.0 thanks

local fr_prng = CV_RegisterVar({
	name = "fr_prng",
	defaultvalue = "0/6278/975/39207/45678/@",
	flags = CV_NETVAR,
	possiblevalue = nil
})

-- initial values are magic numbers from the other script lol
local fr_prng_local_t = 0
local fr_prng_local_x = 6278
local fr_prng_local_y = 975
local fr_prng_local_z = 39207
local fr_prng_local_w = 45678

-- evil bit shift fuckery
local function N_Random()
	fr_prng_local_t = fr_prng_local_x ^^ (fr_prng_local_x << 11)
	fr_prng_local_x, fr_prng_local_y, fr_prng_local_z, fr_prng_local_w = fr_prng_local_y, fr_prng_local_z, fr_prng_local_w, fr_prng_local_w ^^ (fr_prng_local_w >> 19) ^^ fr_prng_local_t ^^ (fr_prng_local_t >> 8)
	return fr_prng_local_w
end

-- then we reimplement every baseline random function so i can find and replace them all
local function N_RandomKey(n)
    return abs(N_Random() % n)
end
local function N_RandomRange(a, b)
    return a + abs(N_Random() % (b - a + 1))
end
local function N_RandomDatas()
    return d
end

local bluescore = 0 -- team score values are ephemeral until finish conditions are met, which forces a recalc
local orangescore = 0 -- so you can probably do whatever you want with this
local bluename = "DON'T WORRY ABOUT THIS" -- this is nice because it lets me instantly know when the script bailed in team generation
local orangename = "IT'S PROBABLY FINE?" -- but you should probably never see it
local localplayer = nil -- UHHHHHHHHHH
local consoleprefix = "\131"
local blowout = false -- are we in a fatal ko? should we do things that fatal kos do?
local fakepostracemusic = 0 -- this timer delays fatal music so kart doesn't immediately stomp on it with an audio file padded by 10 seconds of silence (thanks)
local doteamstuff = true
local bossmode = false
local bossplayer = nil -- gotta keep track of who the boss is to apply boss-specific mechanics
local bossfocused = "@" -- the player currently being watched for boss selection; if fr_bosschance = 100 this makes them unpickable, if fr_bosschance < 100 it forces them to be picked
local bossrestock = true -- whether boss should be given bonus item stock (true unless they've already received it for this pull)
local helpfuladvice = 1 -- random index for postrace tips
local ffasnark = 1 -- random index for FFA subtitle
local finalrecalc = false -- have we locked in final scores?
local bossgotemname = nil -- who last nailed the boss?
local bossprotect = false -- is the boss receiving a pity item after a hit?
local bossgotemposition = 15 -- where was the boss when they got hit?
local bossgotemtimer = 0 -- hud timer for ghetto boss killfeed
local prettyposition = {"1st", "2nd", "3rd", "4th", "5th", "6th", "7th", "8th", "9th", "10th", "11th", "12th", "13th", ":|", ":[", ">:["}
local savedtheworld = nil -- should we do special celebrations for 1 player beating a boss, or leader bonus deciding a normal teams game?
local restorecolors = true -- have we written colors back to teams-mode players during intermission yet? (gotta preserve personal colors for mixed games)

-- just in case.
local function sanitizebossname(s)
	return s:gsub("%W", "")
end

-- serialize prng state to a cvar so that replays can read it
local function N_WriteRandomToCVars()
	COM_BufInsertText(server, 'fr_prng "'..fr_prng_local_t.."/"..fr_prng_local_x.."/"..fr_prng_local_y.."/"..fr_prng_local_z.."/"..fr_prng_local_w.."/"..sanitizebossname(bossfocused)..'"')
end

-- deserlialize prng state from a cvar so that replays sync
local function N_ReadRandomFromCVars()
	local t = {}
	for str in string.gmatch(fr_prng.string, "([^\/]+)") do
		table.insert(t, str)
	end
	fr_prng_local_t = t[1]
	fr_prng_local_x = t[2]
	fr_prng_local_y = t[3]
	fr_prng_local_z = t[4]
	fr_prng_local_w = t[5]
	bossfocused = t[6]
end

addHook("NetVars", function(net)
	bluename = net(bluename)
	orangename = net(orangename)
	blowout = net(blowout)
	fakepostracemusic = net(fakepostracemusic)
	doteamstuff = net(doteamstuff)
	bossmode = net(bossmode)
	bossplayer = net(bossplayer)
	helpfuladvice = net(helpfuladvice)
	finalrecalc = net(finalrecalc)
	ffasnark = net(ffasnark)
	bossfocused = net(bossfocused)
	bossrestock = net(bossrestock)
	bossgotemname = net(bossgotemname)
	bossgotemposition = net(bossgotemposition)
	bossgotemtimer = net(bossgotemtimer)
	bossprotect = net(bossprotect)
	restorecolors = net(restorecolors)
	fr_prng_local_t = net(fr_prng_local_t)
	fr_prng_local_x = net(fr_prng_local_x)
	fr_prng_local_y = net(fr_prng_local_y)
	fr_prng_local_z = net(fr_prng_local_z)
	fr_prng_local_w = net(fr_prng_local_w)
end)

-- allocate sounds
freeslot("sfx_mugen") -- FATAL KO
freeslot("sfx_fatal") -- fatal music
freeslot("sfx_frboss") -- boss announcement
freeslot("sfx_fmssb0") -- generic game mode announcement
freeslot("sfx_fmffa") -- FREE FOR ALL
freeslot("sfx_fmteam") -- TEAM BATTLE
freeslot("sfx_fmdblk") -- teams mode tie (DOUBLE KO!)
freeslot("sfx_fmbshc") -- hitconfirm on boss
freeslot("sfx_fmpnch") -- pinch hitconfirm on winning boss
freeslot("sfx_fmstw") -- clutch win: saved the world!

local FRteams = {
	{blue = "BLUE", orange = "ORANGE", noflip = true},
	{blue = "COKE", orange = "PEPSI"},
	{blue = "SUBS", orange = "DUBS"},
	{blue = "ANIME", orange = "NO ANIME"},
	{blue = "SWORD", orange = "DRILL"},
	{blue = "SUPER NINTENDO", orange = "GENESIS"},
	{blue = "SIT", orange = "STAND"},
	{blue = "RIGHT", orange = "LEFT", noflip = true},
	{blue = "SIT", orange = "STAND"},
	{blue = ":D?", orange = ":D?"},
	{blue = "E", orange = "A"},
	{blue = "ROSE", orange = "CHAOTIX"},
	{blue = "HERO", orange = "DARK"},
	{blue = "SLIP", orange = "TIDE"},
	{blue = "FACE", orange = "TRADE"},
	{blue = "RAP", orange = "COUNTRY"},
	{blue = "ORBI", orange = "JAWZ"},
	{blue = "REAL", orange = "ASS"},
	{blue = "SYNCH", orange = "FAILURE"},
	{blue = "SIT", orange = "STAND"},
	{blue = "RUST", orange = "GO"},
	{blue = "TATE", orange = "YOKO"},
	{blue = "RUST", orange = "GO"},
	{blue = "LAWN", orange = "MOWER"},
	{blue = "TIRED", orange = "ANGRY"},
	{blue = "A", orange = "1"},
	{blue = "LASER", orange = "BOMB"},
	{blue = "PAD", orange = "STICK"},
	{blue = "PAD", orange = "KEYBOARD"},
	{blue = "WIFI", orange = "ETHERNET"},
	{blue = "COFFEE", orange = "TEA"},
	{blue = "LIFE", orange = "HOMETOWN"},
	{blue = "ADVENTURE", orange = "BOOST"},
	{blue = "WAKEUP BLOCK", orange = "WAKEUP DP"},
	{blue = "ZONERS", orange = "GRAPPLERS"},
	{blue = "WARIO LAUGHING", orange = "EASY"},
	{blue = "BLAZBLUE", orange = "GUILTY GEAR"},
	{blue = "98", orange = "2002"},
	{blue = "TREASURE", orange = "PLATINUM"},
	{blue = "ITG", orange = "DDR"},
	{blue = "POP'N MUSIC", orange = "BEATMANIA"},
	{blue = "ANALOG", orange = "DIGITAL"},
	{blue = "MINECRAFT", orange = "TERRARIA"},
	{blue = "CAPCOM", orange = "SNK"},
	{blue = "CAPCOM", orange = "MARVEL"},
	{blue = "GENESIS", orange = "MEGA DRIVE"},
	{blue = "GIF WITH A HARD G", orange = "GIF WITH A SOFT G"},
	{blue = "PAL", orange = "NTSC"},
	{blue = "FM TOWNS", orange = "X68000"},
	{blue = "PRIDE", orange = "ACCOMPLISHMENT"},
	{blue = "FUN", orange = "GLORY"},
	{blue = "C64", orange = "AMIGA"},
	{blue = "SQUID", orange = "KID"},
	{blue = "STAB", orange = "STOMP"},
	{blue = "SLASH", orange = "BUST"},
	{blue = "ADVANCED", orange = "EXTRA"},
	{blue = "CAKE", orange = "ICE CREAM"},
	{blue = "LOW", orange = "OVERHEAD"},
	{blue = "STRIKE", orange = "THROW"},
	{blue = "HIDDEN MISSILES", orange = "SPIRAL SWORDS"},
	{blue = "CLASSIC", orange = "MODERN"},
	{blue = "PAST", orange = "FUTURE"},
	{blue = "PINEAPPLE ON PIZZA", orange = "NO PINEAPPLE ON PIZZA"},
	{blue = "SHOVEL", orange = "SHIELD"},
	{blue = "ICE CLONE", orange = "TOM BRADY", noflip = true},
	{blue = "NETFLIX", orange = "CHILL"},
	{blue = "SUB-ZERO", orange = "SCORPION", noflip = true},
	{blue = "YANNY", orange = "LAUREL"},
	{blue = "BLACK AND BLUE", orange = "WHITE AND GOLD", noflip = true},
	{blue = "ALIEN", orange = "PREDATOR"},
	{blue = "SCORING", orange = "SURVIVAL"},
	{blue = "CAVE", orange = "RAIZING"},
	{blue = "MICRODODGE", orange = "MACRODODGE"},
	{blue = "GRANBLUE", orange = "F/GO"},
	{blue = "PUYO PUYO", orange = "TETRIS"},
	{blue = "KANCOLLE", orange = "AZUR LANE"},
	{blue = "LIGHT", orange = "WILY"},
	{blue = "PROTOMAN", orange = "BASS"},
	{blue = "CRT", orange = "LCD"},
	{blue = "MELTY BLOOD", orange = "BEING INDOORS"},
	{blue = "BOXER", orange = "DICTATOR"},
	{blue = "GESTALT", orange = "REPLICANT"},
	{blue = "NARUTO", orange = "BLEACH"},
	{blue = "KATANA", orange = "GREATSWORD"},
	{blue = "WHIP", orange = "SPEAR"},
	{blue = "DIVE", orange = "KICK"},
	{blue = "GUN", orange = "ALSO A GUN"},
	{blue = "MEAT", orange = "CANDY"},
	{blue = "GRAY", orange = "GREY"},
	{blue = "GAINAX", orange = "TRIGGER"},
	{blue = "AEROWALK", orange = "FACING WORLDS"},
	{blue = "UNITY", orange = "UNREAL"},
	{blue = "TANK", orange = "HEALER"},
	{blue = "HEAVEN", orange = "HELL"},
	{blue = "FRENCH FRIES", orange = "ONION RINGS"},
	{blue = "HARDSTYLE", orange = "PSYTRANCE"},
	{blue = "FIGHT", orange = "FLIGHT"},
	{blue = "BUNNYHOP", orange = "STRAFEJUMP"},
	{blue = "KARIN", orange = "SAKURA"},
	{blue = "BOUND", orange = "SCREW"},
	{blue = "EVADE", orange = "PARRY"},
	{blue = "SQUARE ENIX", orange = "PC PORTS"},
	{blue = "CRAZY", orange = "STUPID"},
	{blue = "TYRONESAMA", orange = "NULLGUARDS"},
	{blue = "TYRONESAMA", orange = "TYRONESAMA'S MICROPHONE"},
	{blue = "TYRONESAMA", orange = "SPATIAL RELATIONSHIPS"},
	{blue = "PICKING VANILLA LAKE", orange = "HAVING A HUMAN SOUL"},
	{blue = "JUSTICE", orange = "MERCY"},
	{blue = ":>", orange = ":3"},
	{blue = "SWORD ART ONLINE", orange = "LOG HORIZON"},
	{blue = "INFOCOM", orange = "SIERRA"},
	{blue = "RYU", orange = "KEN"},
	{blue = "REI", orange = "ASUKA", noflip = "true"},
	{blue = "AMINGO", orange = "SERVBOT"},
	{blue = "LOVE LIVE", orange = "IM@S"},
	{blue = "ATLUS", orange = "GOOD WRITING"},
	{blue = "LOL", orange = "wwwwwww"},
	{blue = "BEEF", orange = "CHICKEN"},
	{blue = "TABS", orange = "SPACES"},
	{blue = "FAST", orange = "FURIOUS"},
	{blue = "SEASONS", orange = "AGES"},
	{blue = "ALLIANCE", orange = "HORDE"},
	{blue = "HY-DROSS-ITY", orange = "HYDRO CITY"},
	{blue = "BOOM", orange = "TAP"},
	{blue = "SOFTWARE", orange = "OPENGL"},
	{blue = "RACE", orange = "BATTLE"},
	{blue = "MELEE COMMUNITY", orange = "JIGGLYPUFF"},
	{blue = "HUNGRYBOX", orange = "A LITERAL CRAB"},
	{blue = "GOOD MUSIC", orange = "BIG ROOM"},
	{blue = "EAST", orange = "WEST"},
	{blue = "FOOTBALL", orange = "FOOTBALL"},
	{blue = "258-141", orange = "253-141"},
	{blue = "MILK CHOCOLATE", orange = "DARK CHOCOLATE"},
	{blue = "AIRDASH", orange = "DOUBLE JUMP"},
	{blue = "DUAL WIELDING", orange = "TWO-HANDERS"},
	{blue = "THE ENGLISH LANGUAGE", orange = "SPECTATOR TO DIE WHY"},
	{blue = "SOKU", orange = "IAMP"},
	{blue = "GAY ENERGY", orange = "MEME RECTANGLE"},
	{blue = "PERSONA 3", orange = "PERSONA 4"},
	{blue = "WOOMY", orange = "VEEMO"},
	{blue = "HOPE", orange = "DESPAIR"},
	{blue = "ROUGE", orange = "ROGUE"},
	{blue = "ROBOT GIRLS", orange = "SWORD GIRLS"},
	{blue = "TEKKEN", orange = "SOULCALIBUR"},
	{blue = "GOKU", orange = "SUPERMAN"},
	{blue = "LARGE", orange = "IN CHARGE"},
	{blue = "EPHRAIM", orange = "EIRIKA"},
	{blue = "BERSERKER", orange = "WARRIOR"},
	{blue = "HORNMOD IN HARDCODE", orange = "HORNMOD IN GARBAGE"},
	{blue = "SWORDMASTER", orange = "ASSASSIN"},
	{blue = "BLACK MAGE", orange = "WHITE MAGE"},
	{blue = "DANTE", orange = "DONTE"},
	{blue = "KOBE", orange = "YEET"},
	{blue = "SIMON", orange = "RICHTER"},
	{blue = "REPLAY HUT", orange = "SEEDING THE RNG"},
	{blue = "im gay", orange = "i've gay"},
	{blue = "SADU", orange = "MAGNAI"},
	{blue = "AOSTH", orange = "SATAM"},
	{blue = "FRIENDMOD", orange = "COMBIRING"},
	{blue = "SAMPLE TEXT", orange = "BOTTOM TEXT"},
	{blue = "ARRAY", orange = "TABLE"},
	{blue = "METRIC", orange = "FREEDOM"},
	{blue = "CHOCOLATE CHIP", orange = "OATMEAL RAISIN"},
	{blue = "VHS", orange = "BETAMAX"},
	{blue = "ENERGY SWORD", orange = "GRAVITY HAMMER"},
	{blue = "RYBB", orange = "DECKER"},
	{blue = "CHEX QUEST", orange = "MATH BLASTER"},
	{blue = "ALWAYS BET DBZ", orange = "NEVER BET DBZ"},
	{blue = "GAMEPLAY INTEGRITY", orange = "GACHA MECHANICS"},
	{blue = ":D?", orange = ":D!"},
	{blue = "CHROME", orange = "FIREFOX"},
	{blue = "UWU", orange = "OWO"},
	{blue = "LMAO", orange = "SDFHJSDFGKDF"},
	{blue = "CHESS", orange = "GO"},
	{blue = "DREAMCAST", orange = "GAMECUBE"},
	{blue = "SONIC CD (US)", orange = "SONIC CD (JPN)"},
	{blue = "SMOGON", orange = "VGC"},
	{blue = "SODA", orange = "WATER"},
	{blue = "JPG", orange = "PNG"},
	{blue = "X", orange = "ZERO"},
	{blue = "HUMANITY", orange = "REPLOIDS"},
	{blue = "SPRITES", orange = "MODELS"},
	{blue = "HORNMOD 2", orange = "TIMELY RELEASES"},
	{blue = "WII U", orange = "VITA"},
	{blue = "TRACKER", orange = "PIANO ROLL"},
	{blue = "HONEST NEUTRAL", orange = "TK BAD MOON"},
	{blue = "FL STUDIO", orange = "ABLETON"},
	{blue = "DEE", orange = "VEE"},
	{blue = "PLAYER 13", orange = "ACTUALLY RACING"},
	{blue = "TGM", orange = "GUIDELINE"},
	{blue = "WINDIA", orange = "CASPER"},
	{blue = "ARCADE-EXCLUSIVE SHMUPS", orange = "IKARUGA AGAIN"},
	{blue = "HEADPHONES", orange = "SPEAKERS"},
	{blue = "AGGRO", orange = "CONTROL"},
	{blue = "GUITAR", orange = "BASS"},
	{blue = "FRIENDMOD", orange = "HORNMOD"},
	{blue = "SOUND VOLTEX", orange = "GROOVE COASTER"},
	{blue = "ROBOTNIK", orange = "EGGMAN"},
	{blue = "SHORTCUT RESPECTERS", orange = "FEARLESS LAWNMOWERS"},
	{blue = "MIDNIGHT CHANNEL CLASSIC", orange = "MAYONAKA MK. II"},
}

local FRtips = {
	{first = "Throw your weight around!", second = "A sacrificial bump can help nearby teammates get ahead."},
	{first = "A poorly-timed Grow can trash your teammates.", second = "Be careful on dash panels and springs!"},
	{first = "Be careful around lightweight teammates.", second = "It doesn't take much to send them into walls!"},
	{first = "Be careful with deployed items.", second = "Deploy while stationary, and you could catch a teammate by surprise!"},
	{first = "Remember to congratulate your teammates on a job well done!", second = ""},
	{first = "If your teammates are holding defensive items, give them some room to set traps.", second = ""},
	{first = "Everyone makes mistakes.", second = "Don't get too upset over it - there's always next round."},
	{first = "The Look Backward button is a powerful tool.", second = "If a teammate has a speed item, make space for them!"},
	{first = "The SPB supercharges 2nd place's items.", second = "Save it to help an ally take the lead!"},
	{first = "When allies are frontrunning, holding the SPB keeps them safe while they pull ahead.", second = ""},
	{first = "Jawz targeting is twitchy and unforgiving.", second = "Keep steady and fire with care!"},
	{first = "See a teammate's Jawz reticle on you?", second = "Pull away from enemies to give them a clear shot."},
	{first = "Don't complain about your team.", second = "Everyone's trying their best."},
	{first = "Always give it your all.", second = "Your team is counting on you!"},
	{first = "Orbinauts travel faster than Jawz.", second = "Use them to save teammates with style!"},
	{first = "The Ball Hog can cause huge collateral damage.", second = "For best results, point-blank an enemy and pray!"},
	{first = "Hyuudoro doesn't care what team you're on.", second = "With luck, you can coordinate to smuggle items far ahead..."},
	{first = "Don't hit your allies with the sink.", second = "I know, it's tempting."},
	{first = "Mines laid behind you arm very slowly.", second = "With teammates nearby, it's often safer than throwing them."},
	{first = "When using Invincibility, focusing on enemies can help your allies overtake.", second = ""},
	{first = "Don't be selfish with Invincibility and Grow!", second = "Plowing through allies to save time costs you more than it gains."},
	{first = "Eggbox explosions linger for a long time.", second = "If you have one, pull FAR away from your team!"},
	{first = "Your teammates have an arrow over their heads, no matter what color you are.", second = "Having trouble telling friend from foe? Use \135fr_colorhelp\128 to override in-game colors."},
	{first = "i've gay", second = ""},
	{first = "Bump spinning teammates forward to minimize the damage.", second = ""},
	{first = "Holding 1st and 2nd place nearly guarantees a win.", second = "If you're feeling brave, SPB Rush can help a duo leave everyone behind..."},
	{first = "It's not over until it's over.", second = "Fight until the very end - a single mistake could change everything!"},
	{first = "When you're on track for a shutout, your team score will flash rapidly.", second = "Win without giving up points for a FATAL KO."},
	{first = "There are few things in life like an intense rivalry.", second = "Get friends and foes together for crew battles!"},
	{first = "Overtaking an enemy is worth 2 points, no matter where it happens.", second = "Even if you're far behind, one pass could make a difference."},
	{first = "Be careful with tricky eggbox placement!", second = "If a teammate doesn't see you place it, they might be the one that gets hit..."},
	{first = "Carrying your team? Wish you could ditch the deadweight?", second = "Consistently place high, and you might get your wish..."},
}

local FRffa = {
	"Cutthroat, god-fearing Kart racing. Good luck!",
	"TEAM MODE IS SUCKS",
	"It's just a game of who gets memed by the ramp first.",
	"HA HA TIME FOR JAWZ",
	"[bass-boosted SPB noise]",
	"Every man, woman, robot, furry, or vertically oriented car for themselves.",
	"Slope physics are your only friend now.",
	"No friends. Only fear.",
	"Recommended for those with antisocial tendencies.",
	"Who needs the power of friendship anyway?",
	"Hey, at least it's not poker.",
	"Don't hold back. Crush anyone between you and victory!",
	"You are alone. Make the most of it.",
	"Wow, a lone wolf. This person must be really cool.",
	"HELP I'M TRAPPED IN A SNARKY RANDOMIZED MESSAGE FACTORY",
	"NOW! Hit it very hard!",
	"Get hype, throw items, kill God.",
	"It all depends on your skill! (And bumpcode)",
	"Ready your ragespecs. An all-out brawl!",
	"YOU get an Orbinaut, and YOU get an Orbinaut, and YOU...",
	"You ever just die?",
	"Now with 100% less mustard gas.",
	"brb chatbug",
	"[violent horn spam]",
	"Come on, get serious!",
	"The wheel of jank is turning!",
	"YOU GOT INSANITY.",
	"You have selected POWER DRIVE.",
	"Race to the finish!",
	"LET'S GO JUSTIN",
	"To switch to teams mode, press Alt+F4.",
	"Honk if you love solitude.",
	"TIP: Don't choke your rocket start.",
	"You'd better get ready to die.",
	"Is it too late to double-check your controller battery?",
	"Recurring Kart Effect...",
	"Brace for syncfails.",
	"TODO: WRITE MORE OF THESE",
	"stop do kick",
}

local FRbosstitles = { -- listen, don't even ask about the way this is formatted, it made sense at the time
	{pre = "Omega", suf = ""},
	{pre = "Shin", suf = ""},
	{pre = "Dark", suf = ""},
	{pre = "Evil", suf = ""},
	{pre = "Not", suf = ""},
	{pre = "Gold", suf = ""},
	{pre = "Serious", suf = ""},
	{pre = "Literally", suf = ""},
	{pre = "SSJ3", suf = ""},
	{pre = "Awakened", suf = ""},
	{pre = "Super", suf = "II Turbo"},
	{pre = "", suf = "And Smough"},
	{pre = "", suf = "With A Gun"},
	{pre = "Perfect", suf = ""},
	{pre = "", suf = ", The Lonely", nospace = true},
	{pre = "Punished", suf = ""},
	{pre = "Reformed", suf = ""},
	{pre = "Activated", suf = ""},
	{pre = "Devil", suf = ""},
	{pre = "", suf = "With Angry Eyebrows"},
	{pre = "Orbinaut God", suf = ""},
	{pre = "Airshot God", suf = ""},
	{pre = "Palette Swap", suf = ""},
	{pre = "", suf = ", Sniper Extraordinaire", nospace = true},
	{pre = "", suf = ", Never Lucky", nospace = true},
	{pre = "", suf = ", Unironic Joker Main", nospace = true},
	{pre = 'Mike "', suf = '" Ross', nospace = true, noprespace = true},
	{pre = 'Ayman "', suf = '" Saria', nospace = true, noprespace = true},
	{pre = "", suf = "SP",},
	{pre = "", suf = "EX",},
	{pre = "", suf = ", F.O.E!", nospace = true},
	{pre = "DUDE", suf = "LMAO"},
	{pre = "Violent", suf = ""},
	{pre = "", suf = "And Knuckles"},
	{pre = "Rare", suf = ""},
	{pre = "", suf = "++", nospace = true},
	{pre = "", suf = ", Vindicator", nospace = true},
	{pre = "XF3", suf = ""},
	{pre = "Fallen Hero", suf = ""},
	{pre = "Shirtless", suf = ""},
	{pre = "", suf = "Prime"},
	{pre = "", suf = "Black"},
	{pre = "", suf = ", Edgelord Supreme", nospace = true},
	{pre = "Unlimited", suf = ""},
	{pre = "Revolver", suf = ""},
	{pre = "", suf = "the Fallen"},
	{pre = "", suf = "Phase 2"},
	{pre = "", suf = ", Three Lap Magic", nospace = true},
	{pre = "Well-Rested", suf = ""},
	{pre = "", suf = ", THE ABADDON FIGHTER", nospace = true},
	{pre = "", suf = ".EXE", nospace = true},
	{pre = "Masked", suf = ""},
	{pre = "Pink Gold", suf = ""},
	{pre = "", suf = "After A Balanced Breakfast"},
	{pre = "", suf = ", WiFi Warrior", nospace = true},
	{pre = "Tom Clancy's", suf = ""},
	{pre = "", suf = ", A Hideo Kojima Production", nospace = true},
	{pre = "", suf = "Platinum"},
	{pre = "", suf = ", Gamebreaker", nospace = true},
	{pre = "", suf = ", Danmaku Legend", nospace = true},
	{pre = "SD", suf = ""},
	{pre = "Stylish Mode", suf = ""},
	{pre = "", suf = ", Bootshine Hero", nospace = true},
	{pre = "Lingering", suf = ""},
	{pre = "", suf = "From Streets"},
	{pre = "", suf = ", Avatar Of Sorrow", nospace = true},
	{pre = "", suf = "300%"},
	{pre = "K-Groove", suf = ""},
	{pre = "", suf = "(Using Tilt Controls)"},
	{pre = "Chatbugged", suf = ""},
	{pre = "Orochi", suf = ""},
	{pre = "", suf = ", Jawzbringer", nospace = true},
	{pre = "", suf = "'s Little Sister", nospace = true},
	{pre = "LV. 999", suf = ""},
	{pre = "Endless Witch", suf = ""},
	{pre = "twitch.tv/", suf = "", noprespace = true},
	{pre = "Gay Pink", suf = ""},
	{pre = "", suf = "left the game (Synch Failure)"},
}

local function FRlog(p, q) -- debug
	if not fr_debug.value then
		return
	end
	if not p then
		print("FRIENDMOD: HEY MORON, YOU PUT AN INVALID PLAYER INTO A DEBUG PRINT: "..q)
	end
	if not p.name then
		print("FRIENDMOD: HEY MORON, YOU PUT A NON-PLAYER INTO A DEBUG PRINT: "..q)
	end
	print("FRIENDMOD: "..p.name.." >> "..q)
end

local function incomingblowout()
	return bluescore == 0 or orangescore == 0
end

local function supervalid(p)
	return p.FRready and p.mo and (not p.spectator)
end

local function realblue()
	return fr_bluecolorlocal.value and fr_bluecolorlocal.value or fr_bluecolor.value
end

local function realorange()
	return fr_orangecolorlocal.value and fr_orangecolorlocal.value or fr_orangecolor.value
end

local function realskincolor(p)
	if p.FRteam == 1
		return realblue()
	elseif p.FRteam == 2 then
		return realorange()
	else
		return p.skincolor
	end
end

local function blueprefix() -- SHUT UP SHUT UP SHUT UP
	if fr_bluecolorlocal.value
		return colLookup[fr_bluecolorlocal.value]
	end
	return colLookup[fr_bluecolor.value]
end

local function orangeprefix() -- NIGHTMARE NIGHTMARE NIGHTMARE NIGHTMARE
	if fr_orangecolorlocal.value
		return colLookup[fr_orangecolorlocal.value]
	end
	return colLookup[fr_orangecolor.value]
end

local function enemyprefix(x)
	return (x == 1) and orangeprefix() or blueprefix()
end

local function countactive()
	local count = 0
	for p in players.iterate
		if not p.spectator then
			count = $ + 1
		end
	end
	return count
end

local function countblue()
	local bluecount = 0
	for p in players.iterate
		if p.FRteam == 1 then
			bluecount = $ + 1
		end
	end
	return bluecount
end

local function countorange()
	local orangecount = 0
	for p in players.iterate
		if p.FRteam == 2 then
			orangecount = $ + 1
		end
	end
	return orangecount
end

local function finished(p)
	if p.spectator or (not p.mo) then
		return true
	elseif p.pflags & PF_TIMEOVER then
		return true
	elseif p.exiting then
		return true
	end
	return false
end

local function bluefinished()
	for p in players.iterate
		if p.FRteam == 1 and not finished(p)  then
			return false
		end
	end
	return true
end

local function bluenotfinished()
	for p in players.iterate
		if p.FRteam == 1 and finished(p)  then
			return false
		end
	end
	return true
end

local function orangefinished()
	for p in players.iterate
		if p.FRteam == 2 and not finished(p)  then
			return false
		end
	end
	return true
end

local function orangenotfinished()
	for p in players.iterate
		if p.FRteam == 2 and finished(p)  then
			return false
		end
	end
	return true
end

local function allfinished()
	for p in players.iterate
		if not finished(p) then
			return false
		end
	end
	return true
end

local function teamname(p)
	return (p.FRteam == 1) and bluename or orangename
end

local function enemyname(p)
	return (p.FRteam == 1) and orangename or bluename
end

local function teamprefix(p)
	return (p.FRteam == 1) and blueprefix() or orangeprefix()
end

local function enemyprefix(p)
	return (p.FRteam == 1) and orangeprefix() or blueprefix()
end

local function bluenameoverride()
	return fr_bluename.string != "Random"
end

local function orangenameoverride()
	return fr_orangename.string != "Random"
end

local function teamstied()
	if bossmode then
		return (bluescore == 1)
	else
		return (bluescore == orangescore)
	end
end

local function assignteam(p, team)
	p.FRteam = team
	FRlog(p, "Assigned to team "..p.FRteam)
	--chatprintf(p, p.name..", you are on "..teamname(p).."! Defeat "..enemyname(p).."!", true)
end

local function teamwinning(p)
	if bossmode then
		if bluescore == 1 then
			return true
		end
		if p.FRteam == 1 and bluescore > 0 then
			return true
		elseif p.FRteam == 2 and bluescore == 0 then
			return true
		end
		return false
	end
	if (p.FRteam == 1 and bluescore > orangescore) or (p.FRteam == 2 and orangescore > bluescore) then
		return true
	end
	return false
end

local function winningprefix()
	return (bluescore > orangescore) and blueprefix() or orangeprefix()
end

local function autoassignteam(p, ...)
	if p.FRteam then
		FRlog(p, "Already assigned a team")
		return
	end
	if p.spectator then
		FRlog(p, "*** WHY ARE YOU GIVING A SPECTATOR A TEAM *** ")
		p.FRteam = nil
		return
	end
	if bossmode then
		FRlog(p, "bossmode lol, go to blue")
		assignteam(p, 1)
		return
	end
	if fr_crewbattle.value then
		FRlog(p, "Crews are on")
		local matchedbluecrew = nil
		local matchedorangecrew = nil
		if bluenameoverride() then
			matchedbluecrew = string.find(string.lower(p.name), string.lower(fr_bluename.string), 1, true)
			if not matchedbluecrew and p.HMclan then
				matchedbluecrew = string.find(string.lower(p.HMclan), string.lower(fr_bluename.string), 1, true)
			end
		end
		if orangenameoverride() then
			matchedorangecrew = string.find(string.lower(p.name), string.lower(fr_orangename.string), 1, true)
			if not matchedorangecrew and p.HMclan then
				matchedorangecrew = string.find(string.lower(p.HMclan), string.lower(fr_orangename.string), 1, true)
			end
		end
		if bluenameoverride() then
			if matchedbluecrew then
				FRlog(p, "Crew assigning to team 1")
				assignteam(p, 1)
				return
			end
		end
		if orangenameoverride() then
			if matchedorangecrew then
				FRlog(p, "Crew assigning to team 2")
				assignteam(p, 2)
				return
			end
		end
		if not fr_crewfill.value then
			FRlog(p, "Crewfill disabled")
			if bluenameoverride() and not orangenameoverride() and not matchedbluecrew then
				FRlog(p, "Force pushing to team 2")
				assignteam(p, 2)
				return
			elseif orangenameoverride() and not bluenameoverride() and not matchedorangecrew then
				FRlog(p, "Force pushing to team 1")
				assignteam(p, 1)
				return
			end
		end
		FRlog(p, "...but didn't match a crew")
	end
	if ... then
		FRlog(p, "team assign early out, doing crews first")
		return
	end
	if countblue() == countorange() then
		FRlog(p, "Team assigned randomly")
		assignteam(p, N_RandomRange(1, 2))
	else
		FRlog(p, "Team imbalance")
		if countblue() > countorange() then
			assignteam(p, 2)
		else
			assignteam(p, 1)
		end
	end
end

local function bossflash()
	bossplayer.kartstuff[k_itemblink] = TICRATE
	bossplayer.kartstuff[k_itemblinkmode] = 2
	S_StartSoundAtVolume(nil, sfx_itrolk, 255, bossplayer)
	S_StartSoundAtVolume(nil, sfx_ruby2, 255, bossplayer)
end

local function welcometofuckingdie(p)
	p.pflags = $|PF_TIMEOVER
	P_DamageMobj(p.mo, nil, nil, 10000)
	S_StartSound(p.mo, sfx_kc3b)
	K_SpawnMineExplosion(p.mo, p.skincolor)
	P_DamageMobj(p.mo, nil, nil, 10000)
end

local function doframeshit(p)
	local mobj = p.FRoverhead
	local flicker = false
	if not mobj.tracer then
		return
	end
	if p.kartstuff[k_itemroulette] then -- i am here to duplicate vanilla game behavior, not ask questions.
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|(((mobj.target.player.kartstuff[k_itemroulette] % (13*3)) / 3) + 1)
	elseif p.kartstuff[k_stolentimer] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_HYUDORO
		flicker = true
	elseif p.kartstuff[k_stealingtimer] > 0 and (leveltime % 2) then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_HYUDORO
	elseif p.kartstuff[k_eggmanexplode] > 1 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_EGGMAN
		flicker = true
	elseif p.kartstuff[k_rocketsneakertimer] > 1 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_ROCKETSNEAKER
		flicker = true
	elseif p.kartstuff[k_growshrinktimer] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_GROW
	elseif p.kartstuff[k_itemtype] and p.kartstuff[k_itemamount] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		if p.kartstuff[k_itemtype] == KITEM_ORBINAUT then
			mobj.tracer.sprite = SPR_ITMO
			mobj.tracer.frame = FF_FULLBRIGHT|(min(mobj.target.player.kartstuff[k_itemamount]-1, 3))
		elseif p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY then
			mobj.tracer.sprite = SPR_ITMI
			mobj.tracer.frame = FF_FULLBRIGHT|((leveltime % (7*3)) / 3)
		elseif p.kartstuff[k_itemtype] == KITEM_SAD
			mobj.tracer.sprite = SPR_ITEM
			mobj.tracer.frame = FF_FULLBRIGHT
		else
			p.FRoverhead.tracer.sprite = SPR_ITEM
			p.FRoverhead.tracer.frame = FF_FULLBRIGHT|(p.kartstuff[k_itemtype])
		end
		if p.kartstuff[k_itemheld] then
			flicker = true
		end
	else
		p.FRoverhead.state = S_PLAYERARROW
		p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
	end
	if flicker then
		if leveltime % 2 then
			-- p.FRoverhead.tracer.flags2 = $ & (~MF2_DONTDRAW)
		else
			p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
		end
	end
end

local function spawnoverhead(p)
	p.FRoverhead = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p)+16*FRACUNIT, MT_PLAYERARROW)
	p.FRoverhead.target = p.mo
end

local function spawnwanted(p)
	p.FRwanted = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p)+16*FRACUNIT, MT_PLAYERWANTED)
	p.FRwanted.target = p.mo
end

local function FYShuffle(tInput)
	local tReturn = {}
    for i = #tInput, 1, -1 do
        local j = N_RandomRange(1, i)
        tInput[i], tInput[j] = tInput[j], tInput[i]
        table.insert(tReturn, tInput[i])
    end
    return tReturn
end

local function buildbossteamname(p)
	FRlog(p, "building boss name")
	local bosstitle = N_RandomRange(1, #FRbosstitles)
	local bossconditionalspace = FRbosstitles[bosstitle].nospace and "" or " "
	local bossconditionalprespace = FRbosstitles[bosstitle].noprespace and "" or " "
	if bossconditionalspace and FRbosstitles[bosstitle].suf == "" then
		bossconditionalspace = ""
	end
	if bossconditionalprespace and FRbosstitles[bosstitle].pre == "" then
		bossconditionalprespace = ""
	end
	local formattedname = string.gsub(p.name, ".*| ?", "")
	return FRbosstitles[bosstitle].pre..bossconditionalprespace..formattedname..bossconditionalspace..FRbosstitles[bosstitle].suf
end

local function becometheboss(p)
	FRlog(p, "promoting to boss")
	if countorange() != 0 then
		FRlog(p, "but there's already a boss??")
		return
	end
	orangename = buildbossteamname(p)
	assignteam(p, 2)
	bossplayer = p
	p.FRlastboss = true
end

local function FRinit(p) 
	FRlog(p, "initalizing")
	p.FRteam = nil
	p.FRfinished = nil
	p.FRstasis = nil
	p.FRoneframedelay = nil -- AAAAAAAAAAAAAAA
	p.FRreprisal = 0
	p.FRoverhead = nil
	p.FRwanted = nil
	p.personalscore = 0
	p.exiting = 0
	p.FRready = true
	p.FRlastboss = p.FRlastboss or false
	p.FRoldskincolor = p.skincolor
	p.kartstuff[k_roulettetype] = 0
	p.FRlastframeitem = 0
end

local function fr_randomtoggle(p, ...)
	local consolearg = (N_RandomRange(0, 1) and "on" or "off")
	COM_BufInsertText(server, "fr_enabled "..consolearg)
	CONS_Printf(p, consoleprefix.."Teams are now "..consolearg)
end
COM_AddCommand("fr_randomtoggle", fr_randomtoggle, 1)

local function fr_changeblue(p, ...)
	for q in players.iterate
		if string.find(string.lower(q.name), string.lower(...), 1, true) then
			q.FRteam = 1
			CONS_Printf(p, consoleprefix..q.name.." set to blue team")
			return
		end
	end
	CONS_Printf(p, consoleprefix.."Couldn't find a player to reassign")
end
COM_AddCommand("fr_changeblue", fr_changeblue, 1)

local function fr_changeorange(p, ...)
	for q in players.iterate
		if string.find(string.lower(q.name), string.lower(...), 1, true) then
			q.FRteam = 2
			CONS_Printf(p, consoleprefix..q.name.." set to orange team")
			return
		end
	end
	CONS_Printf(p, consoleprefix.."Couldn't find a player to reassign")
end
COM_AddCommand("fr_changeorange", fr_changeorange, 1)

local function fr_manualsave(p, ...) -- mostly for testing
	N_WriteRandomToCVars()
	CONS_Printf(p, consoleprefix.."Saving replay state")
end
COM_AddCommand("fr_manualsave", fr_manualsave, 1)

local function fr_colorhelp(p, ...)
	CONS_Printf(p, consoleprefix.."Use fr_bluecolorlocal and fr_orangecolorlocal to change team colors.")
	CONS_Printf(p, consoleprefix.."If you want those settings to automatically load, place them in a file called 'friendmod.cfg' in your Kart/luafiles directory.")
end
COM_AddCommand("fr_colorhelp", fr_colorhelp, 0)

addHook("IntermissionThinker", do
	N_WriteRandomToCVars()
	if G_BattleGametype() return end -- nah
	if restorecolors and doteamstuff then
		restorecolors = false
		for p in players.iterate do
			p.skincolor = p.FRoldskincolor
		end
	end
end)

addHook("MapChange", do
	N_WriteRandomToCVars()
end)

addHook("MapLoad", do
	FRlog(server, "============ MapLoad hook START!")
	N_ReadRandomFromCVars()
	helpfuladvice = N_RandomRange(1, #FRtips)
	ffasnark = N_RandomRange(1, #FRffa)
	finalrecalc = false
	bossrestock = false
	bossgotemname = nil
	bossgotemtimer = 0
	bossprotect = false
	savedtheworld = nil
	restorecolors = true
	for p in players.iterate do
		--[[ FUCK THIS GAY EARTH, COMPLICATED COLOR RESTORE CODE FROM BEFORE INTERMISSIONTHINKERS
		if p.skincolor == realblue() or p.skincolor == realorange() then
			if p.FRoldskincolor then
				FRlog(p, "setting to old skin color: "..p.FRoldskincolor)
				p.skincolor = p.FRoldskincolor
				if p.mo then
					FRlog(p, "setting mo too")
					p.mo.color = p.skincolor
				end
			end
		else
			-- i feel like there should be logic here but there isn't
		end
		FRlog(p, "skincolor is "..p.skincolor)
		--]]
		p.FRoldskincolor = p.skincolor
		p.FRready = nil
		FRinit(p)
	end
	bossplayer = nil
	local teamnames = N_RandomRange(1, #FRteams)
	bluename = "TEAM "..FRteams[teamnames].blue
	orangename = "TEAM "..FRteams[teamnames].orange
	if not FRteams[teamnames].noflip and N_RandomRange(0, 1) then
		bluename, orangename = $2, $1
	end
	--bluename = blueprefix()..bluename.."\128"
	--orangename = orangeprefix()..orangename.."\128"
	local shuffledplayers = {}
	for p in players.iterate do
		table.insert(shuffledplayers, p)
	end
	FRlog(server, "Shuffling players")
	shuffledplayers = FYShuffle(shuffledplayers)
	if N_RandomRange(1, 100) <= fr_bosschance.value then
		FRlog(server, "boss mode")
		bossmode = true
		bluename = blueprefix()..fr_onesidename.string.."\128"
		for _, v in ipairs(shuffledplayers)
			if v.spectator then
				continue
			end
			local bosstargetname = sanitizebossname(v.name)
			if fr_forceboss.string != "Random" then
				FRlog(v, "Forceboss set, checking name against "..fr_forceboss.string)
				if string.find(string.lower(v.name), string.lower(fr_forceboss.string), 1, true) then
					FRlog(v, "mapload boss assignment: boss by name match")
					becometheboss(v)
				end
			elseif fr_bosschance.value == 100 and bosstargetname != bossfocused then
				FRlog(v, "mapload boss assignment: server forcing bossmode, pick anyone new")
				becometheboss(v)
			elseif fr_bosschance.value != 100 and bosstargetname == bossfocused
				FRlog(v, "mapload boss assignment: server not forcing, picking last game's frontrunner")
				becometheboss(v)
			else
				FRlog(v, "mapload boss assignment: fell through, go home")
				assignteam(v, 1)
				v.FRlastboss = false
			end
		end
		if countorange() == 0 then
			FRlog(server, "mapload boss assignment: somehow we fucked up. pick somebody")
			for _, v in ipairs(shuffledplayers)
				if v.spectator then
					continue
				end
				becometheboss(v)
				break
			end
		end
	else
		FRlog(server, "no boss")
		bossmode = false
		FRlog(server, "Assigning teams from shuffle")
		if fr_crewbattle.value then
			for _, v in ipairs(shuffledplayers)
				autoassignteam(v, true)
			end
		end
		for _, v in ipairs(shuffledplayers)
			autoassignteam(v)
		end
	end

	FRlog(server, "Doing overrides")
	if bluenameoverride() then
		--bluename = blueprefix().."TEAM "..bluenameoverride.."\128"
		bluename = fr_bluename.string
		if not orangenameoverride() then
			orangename = fr_onesidename.string
		end
	end
	if orangenameoverride() then
		--orangename = orangeprefix().."TEAM "..orangenameoverride.."\128"
		orangename = fr_orangename.string
		if not bluenameoverride() then
			bluename = fr_onesidename.string
		end
	end
	blowout = false
	fakepostracemusic = 0
	
	doteamstuff = false
	if (countactive() > 1 or fr_debug.value) then
		doteamstuff = fr_enabled.value
	end
	if doteamstuff then
		if (countactive() < fr_minplayers.value) then
			FRlog(server, "teams force disabled, not enough players")
			doteamstuff = false
			bossmode = false
		elseif (N_RandomRange(1,100) > fr_teamchance.value) then
			FRlog(server, "teams force disabled, failed random chance")
			doteamstuff = false
			bossmode = false
		end
	end
end)

addHook("ThinkFrame", function()
	N_Random() -- advance for no reason to """seed"""
	if G_BattleGametype() return end -- nah
	if fr_bosschance.value == 100 then
		for p in players.iterate
			if p == bossplayer then
				bossfocused = p.name
			end
		end
	else
		for p in players.iterate
			if p.kartstuff[k_position] == 1 then
				bossfocused = p.name
			end
		end
	end
	if leveltime == 5 then
		if bossmode and doteamstuff then
			S_StartSound(nil, sfx_frboss)
		else
			S_StartSound(nil, sfx_fmssb0)
			if doteamstuff then
				S_StartSound(nil, sfx_fmteam)
			else
				S_StartSound(nil, sfx_fmffa)
			end
		end
	end
	if (countactive() < 2 and not fr_debug.value) or (not doteamstuff) then
		return
	end
	if bossgotemtimer > 0 then
		bossgotemtimer = $ - 1
	else
		bossgotemname = nil
	end
	FRlog(server, "============== thinkframe start, leveltime "..leveltime)
	FRlog(server, "bluecolorlocal: "..fr_bluecolorlocal.value)
	FRlog(server, "orangecolorlocal: "..fr_orangecolorlocal.value)
	if bossmode then
		FRlog(bossplayer, "BOSSMODE ACTIVE!")
	end
	for p in players.iterate do
		if leveltime < 10 then
			continue
		end
		if not p.FRoldskincolor then
			p.FRoldskincolor = p.skincolor -- why do I have to do this
		end
	end
	for p in players.iterate do
		if not p.FRconfigloaded then
			--COM_BufInsertText(p, "exec friendmod.cfg -noerror")
			p.FRconfigloaded = true
		end
		if p.spectator then
			FRlog(p, "stripping team from spectator")
			p.FRteam = false
		end
		if not p.mo then
			FRlog(p, "doesn't real")
			continue
		end
		if not p.valid then
			FRlog(p, "invalid?")
			continue
		end
		FRlog(p, "running first iterator")
		local mo = p.mo
		if not p.FRready then
			FRinit(p)
		end
		FRlog(p, "realskincolor: "..realskincolor(p))
		autoassignteam(p)
		if not p.mo.colorized and (leveltime > 5) then
			mo.color = realskincolor(p)
			p.skincolor = realskincolor(p)
		end
		if p.FRreprisal > 0 then
			p.FRreprisal = $ - 1
		end
		if not finalrecalc then
			p.personalscore = 0
			p.personalpassed = 0
			for q in players.iterate do
				if p.FRteam != q.FRteam and p.kartstuff[k_position] < q.kartstuff[k_position] then
					p.personalpassed = $ + 1
					p.personalscore = $ + 2
				end
			end
			--local kicker = ")"
			if p.kartstuff[k_position] == 1 then
				p.personalscore = $ + 1
				--kicker = " + 1 for winning!)"
			end
		end
		FRlog(p, "exiting: "..p.exiting)
		if p.FRteam then
			FRlog(p, "team: "..p.FRteam)
		else
			FRlog(p, "WTF, how did we get here without a team assignment")
		end
		
		if bossmode then -- the bossmode block
			if bossprotect and p == bossplayer then
				bossprotect = false
				if p.kartstuff[k_itemtype] == 0 and fr_bossprotectamount.value and (fr_bossprotectfront.value or bossplayer.kartstuff[k_position] != 1) then
					p.kartstuff[k_itemtype] = fr_bossprotectitem.value
					p.kartstuff[k_itemamount] = fr_bossprotectamount.value
					bossflash()
					bossrestock = false
				end
			end
			if p == bossplayer then
				if leveltime == (5*TICRATE) and fr_bossstartamount.value > 0 then
					p.kartstuff[k_itemtype] = fr_bossstartitem.value
					p.kartstuff[k_itemamount] = fr_bossstartamount.value
					bossrestock = false
					bossflash()
				end
				if bossrestock and bossplayer.kartstuff[k_position] != 1 and bossplayer.FRlastframeitem == 0 then
					local okitems = {true, false, false, true, true, true, true, true, false, false, false, false, false, false, false, true} -- lol
					if p.kartstuff[k_itemtype] then
						if okitems[p.kartstuff[k_itemtype]] then
							if (p.kartstuff[k_itemamount] == 1 and fr_bossscalerestock.value) then
								p.kartstuff[k_itemamount] = $ + (fr_bossrestock.value / 2)
							else
								p.kartstuff[k_itemamount] = $ + fr_bossrestock.value
							end
							bossrestock = false
						end
					end
				else
					if p.kartstuff[k_itemamount] == 0 then
						bossrestock = true
					end
				end
			end
			if p.kartstuff[k_roulettetype] != 2 then
				if p == bossplayer and fr_bosskarma.value then
					if p.kartstuff[k_position] != 1 then
						p.kartstuff[k_roulettetype] = 1
					else
						p.kartstuff[k_roulettetype] = 0
					end
				elseif fr_worldkarma.value
					if p.kartstuff[k_position] > bossplayer.kartstuff[k_position] then
						p.kartstuff[k_roulettetype] = 1
					else
						p.kartstuff[k_roulettetype] = 0
					end
				end
			end
			if p != bossplayer and p.FRlastframeitem == 0 and p.kartstuff[k_itemtype] > 0 then
				if not fr_worldpower.value and (p.kartstuff[k_position] <= bossplayer.kartstuff[k_position] or fr_worldpoweralways.value) then
					if p.kartstuff[k_itemtype] == KITEM_GROW or p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or p.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER then
						p.kartstuff[k_itemtype] = fr_worldreplaceitem.value
						p.kartstuff[k_itemamount] = fr_worldreplaceamount.value
					end
				end
				if not fr_worldjawz.value and (p.kartstuff[k_position] <= bossplayer.kartstuff[k_position] or fr_worldjawzalways.value) then
					if p.kartstuff[k_itemtype] == KITEM_JAWZ and p.kartstuff[k_itemamount] > 1 then
						p.kartstuff[k_itemamount] = 1
					end
				end
				if bossplayer.kartstuff[k_position] != 1
					if p.kartstuff[k_itemtype] == KITEM_SPB then
						p.kartstuff[k_itemtype] = fr_bossspbgone.value
					end
				end
				if p.kartstuff[k_itemtype] == KITEM_SHRINK then
					p.kartstuff[k_itemtype] = fr_bossshrinkbgone.value
				end
			end
			p.FRlastframeitem = p.kartstuff[k_itemtype]
		end
		
		FRlog(p, "score: "..p.personalscore)
		FRlog(p, "oldskincolor: "..p.FRoldskincolor)
		FRlog(p, "finished: "..(finished(p) and "true" or "false"))
		FRlog(p, "timeover: "..((p.pflags & PF_TIMEOVER) and "true" or "false"))
		
		if p.playerstate == PST_LIVE and p.valid then
			if bossmode then
				if p == bossplayer then
					if not p.FRwanted then
						spawnwanted(p)
					elseif not p.FRwanted.valid then
						spawnwanted(p)
					end
					if p.FRwanted.valid then
						if (leveltime % 6) < 3 then
							p.FRwanted.colorized = true
							p.FRwanted.color = SKINCOLOR_CRIMSON
						else
							p.FRwanted.colorized = true
							p.FRwanted.color = SKINCOLOR_WHITE
						end
						if localplayer == bossplayer then
							p.FRwanted.flags2 = $|MF2_DONTDRAW
						else
							p.FRwanted.flags2 = $ & (~MF2_DONTDRAW)
						end
					end
				end
			end
			if not p.FRoverhead then
				FRlog(p,"no overhead, spawning")
				spawnoverhead(p)
			elseif not p.FRoverhead.valid then
				FRlog(p,"invalid overhead, spawning")
				spawnoverhead(p)
			end
			if p.FRoverhead.valid then
				FRlog(p,"doing overhead stuff")
				p.FRoverhead.state = S_PLAYERARROW_BOX
				p.FRoverhead.scale = FRACUNIT
				p.FRoverhead.angle = R_PointToAngle(p.FRoverhead.x, p.FRoverhead.y) + ANGLE_90;
				p.FRoverhead.color = realskincolor(p)
				if localplayer != nil and localplayer.valid and p.valid and p.FRoverhead.tracer and (not splitscreen) then
					if p.FRteam == localplayer.FRteam and p != localplayer and p.playerstate == PST_LIVE then
						p.FRoverhead.flags2 = $ & (~MF2_DONTDRAW)
						p.FRoverhead.tracer.flags2 = $ & (~MF2_DONTDRAW)
						FRlog(p,"draw overhead please")
					else
						p.FRoverhead.flags2 = $|MF2_DONTDRAW
						p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
						FRlog(p,"don't draw overhead please")
					end
				end
				doframeshit(p)
				FRlog(p,"overhead color: "..p.FRoverhead.color)
			end
		end
	end
	
	if not finalrecalc then
		FRlog(server, "tallying scores")
		bluescore = 0
		orangescore = 0
		for p in players.iterate do
			if p.FRready and p.mo and not p.spectator then
				if p.FRteam == 1 then
					bluescore = $ + p.personalscore
				else
					orangescore = $ + p.personalscore
				end
			end
		end
	end
	
	local thinkbluefinished = bluefinished()
	local thinkorangefinished = orangefinished()
	local thinkbluenotfinished = bluenotfinished()
	local thinkorangenotfinished = orangenotfinished()
	
	if not blowout then
		if thinkbluefinished and thinkorangenotfinished then
			FRlog(server, "blue blowout")
			blowout = true
			for p in players.iterate do
				FRlog(p, "blue blowout check")
				if not supervalid(p) then
					continue
				end
				if p.FRteam == 2 and not (p.pflags & PF_TIMEOVER) then
					FRlog(p, "blue blowout die")
					welcometofuckingdie(p)
				end
			end
		elseif thinkbluenotfinished and thinkorangefinished and (not bossmode) then
			FRlog(server, "orange blowout")
			blowout = true
			for p in players.iterate do
				FRlog(p, "orange blowout check")
				if not supervalid(p) then
					continue
				end
				if p.FRteam == 1 and not (p.pflags & PF_TIMEOVER) then
					FRlog(p, "orange blowout die")
					welcometofuckingdie(p)
				end
			end
		elseif bossmode and (countorange() == 0 or bossplayer.pflags & PF_TIMEOVER) then
			FRlog(server, "bossmode blowout")
			--print("The boss spectated or otherwise disappeared.")
			for p in players.iterate do
				if not supervalid(p) then
					continue
				end
				if p.exiting then
					continue
				end
				p.exiting = 99
			end
			blowout = true
		end
	end
	
	if allfinished() then
		FRlog(server, "finish")
		if not finalrecalc then
			bluescore = 0
			orangescore = 0
			local numberwon = 0
			for p in players.iterate
				if not supervalid(p) then continue end
				local temppersonal = p.personalscore
				p.personalscore = 0
				local finishedfirst = true
				for q in players.iterate
					if not supervalid(q) then continue end
					if p == q then continue end
					if p.realtime < q.realtime or (not (p.pflags & PF_TIMEOVER) and (q.pflags & PF_TIMEOVER)) then
						if p.FRteam != q.FRteam then
							p.personalscore = $ + 2
						end
						if bossmode and p.FRteam == 1 and q.FRteam == 2 then
							numberwon = $ + 1
							savedtheworld = p
						end
					else
						if p.realtime > q.realtime or (p.pflags & PF_TIMEOVER)-- ties for 1st
							finishedfirst = false
						end
					end
				end
				p.FRleader = finishedfirst
				if finishedfirst then
					p.personalscore = $ + 1
				end
				if temppersonal != p.personalscore then
					--print("Post-race scoring changed for "..p.name..": before was "..temppersonal..", after is "..p.personalscore)
				end
				if p.FRteam == 1 then
					bluescore = $ + p.personalscore
				elseif p.FRteam == 2 then
					orangescore = $ + p.personalscore
				end
			end
			if numberwon != 1 then
				savedtheworld = nil
			end
			--print("blue: "..bluescore)
			--print("orange: "..orangescore)
			finalrecalc = true
			if abs(bluescore - orangescore) == 1 and not bossmode then
				for p in players.iterate
					-- this is how you know i'm getting tired of writing this
					if p.FRleader == true and ((p.FRteam == 1 and bluescore > orangescore) or (p.FRteam == 2 and orangescore > bluescore)) then
						savedtheworld = p
					end
				end
			end
		end
		FRlog(server, "allfinish music")
		fakepostracemusic = $ + 1
		FRlog(server, "fakepostracemusic: "..fakepostracemusic)
		if fakepostracemusic == 40 and blowout then
			FRlog(server, "blowout music")
			S_ChangeMusic("fatal", false)
		elseif fakepostracemusic == 1
			S_StopMusic()
			if blowout then
				FRlog(server, "blowout sound")
				S_StartSoundAtVolume(nil, sfx_mugen, 255)
			elseif bossmode and bluescore == 0 then
				FRlog(server, "boss win sound")
				S_ChangeMusic("frover", false, p)
			elseif savedtheworld then
				FRlog(server, "STW sound")
				S_ChangeMusic("fmstw", false, p)
			else
				FRlog(server, "not a blowout")
				for p in players.iterate
					if teamwinning(p) or p.spectator then
						FRlog(p, "kbwin time")
						S_ChangeMusic("kbwin", false, p)
					elseif teamstied() then
						FRlog(p, "what does this even count as")
						S_StartSoundAtVolume(nil, sfx_fmdblk, 255)
					else
						FRlog(p, "kblose time")
						S_ChangeMusic("kblose", false, p)
					end
				end
			end
		end
		local manualexit = false
		FRlog(server, "starting allfinish iterator, time to do manualexit stuff")
		for p in players.iterate
			FRlog(p, "are you real")
			if not supervalid(p) then
				continue
			end
			FRlog(p, "doing allfinish iterator")
			if p.exiting == 99 and not p.FRstasis then
				FRlog(p, "Detonate handler")
				p.FRstasis = 5 * TICRATE - 2
			end
			if p.FRstasis == nil then
				if p.FRoneframedelay == nil then
					p.FRoneframedelay = true
					FRlog(p, "1f delay set")
				else
					FRlog(p, "stasis set")
					p.FRstasis = 10 * TICRATE
				end
			else
				p.FRstasis = $ - 1
				FRlog(p, "stasis ticking "..p.FRstasis)
				if p.FRstasis > 1 and not manualexit then
					p.exiting = 2
					FRlog(p, "exiting is "..p.exiting)
				else
					FRlog(p, "scoreboard set")
					manualexit = true
					FRlog(p, "DID WE SET MANUALEXIT YOU STUPID FUCK: "..(manualexit and "true" or "false"))
					p.pflags = $ & (~PF_TIMEOVER)
					if teamwinning(p) then
						FRlog(p, "Last chance win setup")
						p.realtime = 0
						if not blowout then
							FRlog(p, "win music change")
							S_ChangeMusic("krwin", true, p)
						end
					elseif teamstied() then
						FRlog(p, "Last chance tie?")
						p.realtime = 0
						if not blowout then
							FRlog(p, "win music change")
							S_ChangeMusic("krwin", true, p)
						end
					else
						FRlog(p, "Last chance loss setup")
						p.realtime = 2
						p.pflags = $|PF_TIMEOVER
						if not blowout then
							FRlog(p, "loss music change")
							S_ChangeMusic("krlose", true, p)
						end
					end
				end
			end
		end
		if manualexit then
			FRlog(server, "Manually exiting")
			COM_BufInsertText(server, "exitlevel")
		end
	end
	
	FRlog(server, "thinkframe most likely not on fire!")
end)

hud.add(function(v, p, c) -- AAAAAAAAAAHHHHHHHHHHHHH
	if G_BattleGametype() return end -- nah
	localplayer = p
	if (countactive() < 2 and not fr_debug.value) then
		return
	end
	if not doteamstuff
		if leveltime < (6 * TICRATE + (3 * TICRATE / 4)) then
			local ffaflag = 0
			if leveltime < (3 * TICRATE / 2) then
				ffaflag = (leveltime % 2) and V_70TRANS or 0
			end
			v.drawString(160, 2, "\133FREE FOR ALL", ffaflag, "center")
			v.drawString(160, 12, "GO FOR THE GOLD!", 0, "center")
			local overtaketutorial = FRffa[ffasnark]
			local overtakeoffset = 160 - v.stringWidth(overtaketutorial, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(overtakeoffset, 25, overtaketutorial, V_ALLOWLOWERCASE, "small")
		end
		return
	end
	local bluenamehud = blueprefix()..bluename.."\x80"
	local orangenamehud = orangeprefix()..orangename.."\x80"
	if leveltime < 10 * TICRATE and not splitscreen and not p.spectator then
		if bossmode then
			if p.FRteam == 2 then
				v.drawString(160, 2, "You are "..orangeprefix().."THE BOSS\128!", 0, "center")
				v.drawString(160, 12, "Defeat "..enemyname(p).."!", 0, "center")
			else
				v.drawString(160, 2, "Unite with "..bluenamehud.."!", 0, "center")
				v.drawString(160, 12, "Take down "..orangenamehud.."!", 0, "center")
			end
		else
			if p.FRteam == 1 then -- SHUT UP
				v.drawString(160, 2, "You are on "..bluenamehud..".", 0, "center")
				v.drawString(160, 12, "Defeat "..orangenamehud.."!", 0, "center")
			else
				v.drawString(160, 2, "You are on "..orangenamehud..".", 0, "center")
				v.drawString(160, 12, "Defeat "..bluenamehud.."!", 0, "center")
			end
		end
		local overtaketutorial = "+2 per "..enemyprefix(p).."enemy\128 passed, +1 for first place"
		if bossmode then
			overtaketutorial = orangeprefix().."BOSS WINS\128 if they finish 1st! Stop them at all costs!"
			if p == bossplayer then
				overtaketutorial = "Your items are supercharged! "..orangeprefix().."Finish 1st\128 to win!"
			end
		end
		local overtakeoffset = 160 - v.stringWidth(overtaketutorial, V_ALLOWLOWERCASE, "small") / 2
		v.drawString(overtakeoffset, 25, overtaketutorial, V_ALLOWLOWERCASE, "small")
		local teamattacktutorial = "Team Attack is \133ON\128: watch where you throw!"
		if not fr_teamattack.value then
			teamattacktutorial = "Team Attack is \131OFF\128: get up close and personal!"
		end
		local teamattackoffset = 160 - v.stringWidth(teamattacktutorial, V_ALLOWLOWERCASE, "small") / 2
		v.drawString(teamattackoffset, 30, teamattacktutorial, V_ALLOWLOWERCASE, "small")
		return
	end
	local blueflash = 0
	local orangeflash = 0
	if (leveltime % 10 >= 5 and not incomingblowout()) or (leveltime % 4 >= 2 and incomingblowout()) then
		if bossmode then
			blueflash = (bluescore == 0) and 0 or V_HUDTRANSHALF
			orangeflash = (bluescore == 0) and V_HUDTRANSHALF or 0
		else
			if bluescore > orangescore
				blueflash = V_HUDTRANSHALF
			elseif orangescore > bluescore
				orangeflash = V_HUDTRANSHALF
			end
		end
	end
	if p.FRreprisal and (p.FRreprisal < 60 or not (leveltime % 2)) then
		v.drawString(160, 60, "TEAM DAMAGE!", V_REDMAP, "center")
	end
	if bossmode and bossplayer.valid then
		if bossgotemtimer > 0 then
			if bossgotemtimer < 87 or (leveltime % 2) then
				local bossgotemtext = blueprefix()..bossgotemname.." \128NAILED THE BOSS!"
				if bossgotemposition == 1 then
					bossgotemtext = blueprefix()..bossgotemname.." \128LANDS A MIRACLE HIT!"
				end
				local bossgotemoffset = 160 - v.stringWidth(bossgotemtext, 0, "thin") / 2
				v.drawString(bossgotemoffset, 2, bossgotemtext, 0, "thin")
			end
		else
			local hudbossname = orangeprefix()..orangenamehud
			local hudbossoffset = 160 - v.stringWidth(hudbossname, orangeflash, "thin") / 2
			v.drawString(hudbossoffset, 2, hudbossname, 0, "thin")
		end
		if p == bossplayer and not splitscreen and not bossplayer.exiting then
			local bossremaining = bossplayer.kartstuff[k_position] - 1
			if bossremaining > 0 or splitscreen then
				v.drawString(160, 12, orangeprefix().."PASS "..bossremaining.." TO WIN!", orangeflash, "center")
			else
				v.drawString(160, 12, orangeprefix().."STAY AHEAD!", orangeflash, "center")
			end
		else
			v.drawString(160, 12, orangeprefix()..prettyposition[bossplayer.kartstuff[k_position]].." PLACE", orangeflash, "center")
		end
	else
		if p.FRteam == 1 or splitscreen or p.spectator then
			v.drawString(155, 2, bluenamehud, blueflash, "thin-right")
			v.drawString(165, 2, orangenamehud, orangeflash, "thin")
			if supervalid(p) and not splitscreen then
				v.drawString(155, 12, blueprefix().."+"..p.personalscore.." "..bluescore, V_50TRANS, "right")
			end
			v.drawString(155, 12, blueprefix()..bluescore, blueflash, "right")
			v.drawString(165, 12, orangeprefix()..orangescore, orangeflash, "left")
		else
			v.drawString(155, 2, orangenamehud, orangeflash, "thin-right")
			v.drawString(165, 2, bluenamehud, blueflash, "thin")
			if supervalid(p) and not splitscreen  then
				v.drawString(155, 12, orangeprefix().."+"..p.personalscore.." "..orangescore, V_50TRANS, "right")
			end
			v.drawString(155, 12, orangeprefix()..orangescore, orangeflash, "right")
			v.drawString(165, 12, blueprefix()..bluescore, blueflash, "left")
		end
	end

	local leftoffset = 0
	local rightoffset = 0
	
	if allfinished() then
		if not bossmode then
			if blowout then
				if leveltime%4 >= 2 then
					v.drawString(160, 30, winningprefix().."FATAL KO", 0, "center")
				end
			elseif bluescore > orangescore
				v.drawString(160, 30, bluenamehud.." WINS!", 0,"center")
			elseif orangescore > bluescore
				v.drawString(160, 30, orangenamehud.." WINS!", 0, "center")
			else
				v.drawString(160, 30, "WHAT", 0, "center")
			end
		else
			if blowout then
				v.drawString(160, 30, winningprefix().."FATAL KO", 0, "center")
			elseif savedtheworld then
				local lazyflash = (leveltime % 2) and blueprefix() or "\128"
				v.drawString(160, 30, blueprefix()..savedtheworld.name..lazyflash.." SAVED "..fr_onesidename.string.."!", 0,"center")
			elseif bluescore > 1 then
				v.drawString(160, 30, bluenamehud.." WINS!", 0,"center")
			elseif bluescore == 0 then
				v.drawString(160, 30, orangenamehud.." WINS!", 0, "center")
			else
				v.drawString(160, 30, "WHAT", 0, "center")
			end
		end
	end
	if (finished(p) and not splitscreen) or (allfinished() and splitscreen) then
	
		if not allfinished() then
			local helpfuladvicetext = consoleprefix.."TIP: \128 "..FRtips[helpfuladvice].first
			local helpfuladviceoffset = 160 - v.stringWidth(helpfuladvicetext, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(helpfuladviceoffset, 30, helpfuladvicetext, V_ALLOWLOWERCASE, "small")
			local helpfuladvicetexttwo = FRtips[helpfuladvice].second
			local helpfuladviceoffsettwo = 160 - v.stringWidth(helpfuladvicetexttwo, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(helpfuladviceoffsettwo, 35, helpfuladvicetexttwo, V_ALLOWLOWERCASE, "small")
		end
		if not bossmode then
			local sortedplayers = {}
			for q in players.iterate
				if q.mo and not q.spectator and q.FRready then
					table.insert(sortedplayers, q)
				end
			end
			table.sort(sortedplayers, function(a, b)
				if not (finished(a) == finished(b)) then
					return finished(a)
				end
				return a.personalscore > b.personalscore
			end)
			for _, q in ipairs(sortedplayers)
				local finishflag = V_ALLOWLOWERCASE
				if not finished(q) then
					finishflag = $|V_GRAYMAP|V_50TRANS
				end
				local tempname = q.name
				if q == savedtheworld then
					finishflag = (leveltime % 2) and finishflag or V_ALLOWLOWERCASE|V_YELLOWMAP
					if leveltime % 50 >= 25 then
						tempname = "CLUTCH!"
					end
				end
				if (not splitscreen and q.FRteam == p.FRteam) or (splitscreen and q.FRteam == 1) or (p.spectator and q.FRteam == 1) then
					v.drawString(155, 45 + leftoffset, teamprefix(q)..tempname.." - "..q.personalscore, finishflag, "thin-right")
					leftoffset = $ + 10
				else
					v.drawString(165, 45 + rightoffset, teamprefix(q)..q.personalscore.." - "..tempname, finishflag, "thin")
					rightoffset = $ + 10
				end
			end
		elseif not p.spectator and p.FRexiting != 1 -- shhh. no tears.
			local sortedplayers = {}
			for q in players.iterate
				if q.mo and not q.spectator and q.FRready and not (q.pflags & PF_TIMEOVER) and q.realtime <= bossplayer.realtime and q.FRteam == 1 then
					table.insert(sortedplayers, q)
				end
			end
			table.sort(sortedplayers, function(a, b)
				return a.realtime < b.realtime
			end)
			for _, q in ipairs(sortedplayers)
				local finishflag = V_ALLOWLOWERCASE
				if not finished(q) then
					finishflag = $|V_GRAYMAP|V_50TRANS
				end
				v.drawString(155, 45 + leftoffset, teamprefix(q)..q.name, finishflag, "thin-right")
				v.drawString(165, 45 + leftoffset, teamprefix(q)..prettyposition[q.kartstuff[k_position]], finishflag, "thin")
				leftoffset = $ + 10
			end
		end
	end
end)

local function maybeDoInstashield(p)
	if not fr_teamattack.value then
		K_DoInstashield(p)
	end
end

local function teamattackmirror(p)
	if (fr_teamattack.value or fr_teamreflect.value) and fr_teamwarning.value and not p.exiting then
		if p.FRreprisal < (2 * TICRATE - 10) then
			S_StartSoundAtVolume(nil, sfx_s3k50, 255, p)
			if fr_teamlog.value then
				COM_BufInsertText(server, "echo "..p.name.." attacked a teammate!")
			end
		end
		p.FRreprisal = 2 * TICRATE
	end
	if fr_teamreflect.value then
		S_StartSound(p.mo, sfx_kc3b)
		K_SpawnMineExplosion(p.mo, p.skincolor)
		P_DamageMobj(p.mo, nil, nil, 10000)
		K_DoInstashield(p)
	end
end

local function bossgotem(p)
	if bossgotemtimer < 95 and p != bossplayer and not bossplayer.exiting then
		bossgotemname = p.name
		bossgotemtimer = TICRATE * 3
		bossgotemposition = bossplayer.kartstuff[k_position]
		if bossgotemposition == 1 then
			S_StartSound(nil, sfx_fmpnch)
		else
			S_StartSound(nil, sfx_fmbshc)
		end
		bossprotect = true
	end
end

-- muchos nachos to Snu for battle+ because i'm WAY too dumb to comb through source for this shit
-- a lot of nullguards and valid checks are taken from b+ because i assume they have a purpose and i'm very scared
addHook("ShouldSpin", function(p, inflictor, source)
	if not doteamstuff or G_BattleGametype() then
		return
	end
	if (source and source.player and (p ~= source.player))
	and not (not source.player.kartstuff[k_invincibilitytimer] and (inflictor and inflictor.player and (source.player.kartstuff[k_sneakertimer] or source.player.kartstuff[k_pogospring])))
		if p.kartstuff[k_invincibilitytimer] or (p.kartstuff[k_growshrinktimer] > 0) then
			K_DoInstashield(p)
			return false
		elseif (p.FRteam == source.player.FRteam) then
			teamattackmirror(source.player)
			maybeDoInstashield(p)
			return fr_teamattack.value
		elseif bossmode then
			bossgotem(source.player)
		end
	end
	return
end)

addHook("ShouldSquish", function(p, inflictor, source)
	if not doteamstuff or G_BattleGametype() then
		return
	end
	if (source and source.player and (p ~= source.player))
		if p.kartstuff[k_invincibilitytimer] or (p.kartstuff[k_growshrinktimer] > 0) then
			K_DoInstashield(p)
			return false
		elseif (p.FRteam == source.player.FRteam) then
			teamattackmirror(source.player)
			maybeDoInstashield(p)
			return fr_teamattack.value
		elseif bossmode then
			bossgotem(source.player)
		end
	end
	return
end)

addHook("ShouldExplode", function(p, inflictor, source)
	if not doteamstuff or G_BattleGametype()  then
		return
	end
	if (source and source.player and (p ~= source.player))
		if p.kartstuff[k_invincibilitytimer] or (p.kartstuff[k_growshrinktimer] > 0) then
			K_DoInstashield(p)
			return false
		elseif (p.FRteam == source.player.FRteam) then
			teamattackmirror(source.player)
			maybeDoInstashield(p)
			return fr_teamattack.value
		elseif bossmode then
			bossgotem(source.player)
		end
	end
	return
end)

local flashItems = {MT_EGGMANITEM, MT_EGGMANITEM_SHIELD, MT_BANANA, MT_BANANA_SHIELD, MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_DUD, MT_JAWZ_SHIELD, MT_SSMINE_SHIELD, MT_SSMINE, MT_BALLHOG, MT_SPB, MT_SINK}
for i = 1, #flashItems
	addHook("MobjThinker", function(mo)
		if not doteamstuff or G_BattleGametype() then
			return
		end
		if not fr_teamattack.value then
			if (mo and mo.valid)
				if mo.target and (localplayer and localplayer.valid)
					if (mo.target.player.FRteam == localplayer.FRteam) and (mo.target.player != localplayer) then
						mo.flags2 = $ | MF2_SHADOW
						mo.colorized = true
						mo.color = realskincolor(mo.target.player)
					end
				end
			end
		end
	end, flashItems[i])
end	

rawset(_G, "FRIENDMOD_ToggleTeams", function(...)
	fr_enabled.value = not fr_enabled.value
	return fr_enabled.value
end)

rawset(_G, "FRIENDMOD_CheckTeams", function(...)
	return fr_enabled.value
end)